*! version 1.0.0 05Nov98 PR.
program define branddlg
	version 5.0

	precmd branddlg

	global D_sm4 "Total number of subjects"
	global D_sm5 "Number of subjects per block"
	global D_sm6 "Number of treatments"
	global D_sm7 "Random number seed"

	window control static D_sm4 8 25 100 8
	window control static D_sm5 8 43 100 8
	window control static D_sm6 8 61 100 8
	window control static D_sm7 8 79 100 8

	window control edit 110 25 29 10 D_obs
	window control edit 110 43 29 10 D_blksiz
	window control edit 110 61 29 10 D_treat
	window control edit 110 79 29 10 D_seed

    * Buttons
   	window control button "OK"     20 112 30 16 D_bok
	window control button "Cancel" 65 112 30 16 D_bex
	window control button "Help"  110 112 30 16 D_bhl help

	global D_bhl "whelp branddlg"
	global D_bok "noi brok"
	global D_bex "exit 3000"

	noi capture window dialog "Blocked randomisation" . . 165 150
end

program define brok
	version 5.0
	errrange "$D_blksiz" "$D_sm5" 2 .
	global D_block=$D_obs/$D_blksiz
	errrange "$D_block" "Number of blocks" 1 . = int
	errrange "$D_obs" "$D_sm4" 1 . =
	errrange "$D_treat" "$D_sm6" 2 .
	if "$D_seed"!="" {
		errrange $D_seed "$D_sm7" 1 .
	}
	local tb=$D_blksiz/$D_treat
	errrange `tb' "Number of treatments per block" 1 . "" int
	if _N>0 {
		cap window stopbox rusure "Do you want to clear the current dataset from memory?" "Press OK to clear or Cancel to abort."
		if _rc==0 { drop _all }
	}
	quietly {
		set obs $D_obs
		genlev $D_block $D_blksiz block
		genlev $D_treat 1 treat
		if "$D_seed"!="" { set seed $D_seed }
		tempvar rand
		gen `rand'=uniform()
		sort block `rand'
		gen int subject=_n
	}
	set more off
	list subject block treat, noobs
	set more on
	exit 3000
end
