*! version 3.0.2  PR 28Nov96.
program define mczi /* essentially reproduces mcci.ado with cosmetic changes */
version 4.0
parse "`*'", parse(" ,")
local a "`1'"
local b "`2'"
local c "`3'"
local d "`4'"
confirm integer number `a'
confirm integer number `b'
confirm integer number `c'
confirm integer number `d'
if `a'<0 | `b'<0 | `c'<0 | `d'<0 { 
	di in red "negative numbers invalid"
	exit 498
}
mac shift
mac shift
mac shift
mac shift
#delimit ;
local options "Level(integer $S_level) TB EXTra EXAct CC
	Alab(string) Blab(string) Plab(string) Nlab(string)" ;
#delimit cr
parse "`*'"
if `level'<10 | `level'>99 { 
	local level 95
}
if "`alab'"=="" { local alab "State A" }
if "`blab'"=="" { local blab "State B" }
if "`plab'"=="" { local plab "Positive" }
if "`nlab'"=="" { local nlab "Negative" }
di
_crc4fld `a' `b' `c' `d' "`blab'" "`alab'" "`plab'" "`nlab'" "`plab'" "`nlab'"
local n = `a'+`b'+`c'+`d'

* Allow for continuity correction in hypothesis test (not in CI)

if "`cc'"=="" {
	local chi2 = (`b'-`c')^2/(`b'+`c')
}
else {
	local chi2 = (abs(`b'-`c')-1)^2/(`b'+`c')
}
local z = sign(`b'-`c')*sqrt(`chi2')
local P = chiprob(1,`chi2')

di in gr _n "McNemar's SND (Z) = " in ye %8.3f `z' /* 
	*/ _skip(8) in gr "Pr>|SND| =" in ye %7.4f `P'
if "`cc'"!="" { di in gr "(with continuity correction)" }
if "`exact'"!="" {
	qui bitesti "`b'+`c'" `c' .5
	di _n in gr "P-value (from \`exact' test) = " in ye %7.4f $S_3
}
local p1=(`a'+`c')/`n'
local p2=(`a'+`b')/`n'

di _n in gr "Proportion `plab'" _n /*
 */ _col(9) "`alab'" _col(20) in ye %9.0g `p2' in gr _n /*
 */ _col(9) "`blab'" _col(20) in ye %9.0g `p1' /*
 */ "     " in gr "[`level'% conf. interval]" _n /*
 */ _col(20) "---------     " _dup(20) "-"

local pd=(`b'-`c')/`n'
local sepd=sqrt((`a'+`d')*(`b'+`c')+4*`b'*`c')/(`n'*sqrt(`n'))

* Gardner and Altman formula for se, p 31, is algebraically the same :

local iz=invnorm(1-(1-`level'/100)/2)

* Do not use continuity correction in CI.

local pd0=`pd'-`iz'*`sepd'
local pd1=`pd'+`iz'*`sepd'
di in gr _col(9) "difference " in ye %9.0g `pd' _skip(5) /*
 */ %9.0g `pd0' "  " %9.0g `pd1'
if "`extra'"!="" {
local pr=(`a'+`b')/(`a'+`c')
local selnpr=sqrt((`b'+`c')/((`a'+`b')*(`a'+`c')))
local pr0=exp(ln(`pr')-`iz'*`selnpr')
local pr1=exp(ln(`pr')+`iz'*`selnpr')
di in gr _col(9) "ratio      " in ye %9.0g `pr' _skip(5) /*
 */ %9.0g `pr0' "  " %9.0g `pr1'

local pe=(`b'-`c')/(`b'+`d')
local sepe=1/((`b'+`d')^2)*sqrt(/*
 */ (`b'+`c'+`d')*(`b'*`c'+`b'*`d'+`c'*`d')-`b'*`c'*`d')
local pe0=`pe'-`iz'*`sepe'
local pe1=`pe'+`iz'*`sepe'
di in gr _col(9) "rel. diff. " in ye %9.0g `pe' _skip(5) /*
 */ %9.0g `pe0' "  " %9.0g `pe1'

local o = `b'/`c'
if "`tb'"=="" { 
	local t=`b'+`c'
	quietly cii `t' `b', level(`level')
	local o0 = $S_5/(1-$S_5)
	local o1 = $S_6/(1-$S_6)
	local note "(exact)"
}
else {
	local x=(`b'-`c')/sqrt(`b'+`c')
	local o0 = `o'^(1+`iz'/`x')
	local o1 = `o'^(1-`iz'/`x')
	if `o0'>`o1' { 
		local hold `o0'
		local o0 `o1'
		local o1 `hold'
	}
	local note "(tb)"
}
di _n in gr _col(9) "odds ratio " in ye %9.0g `o' _skip(5) /*
 */ %9.0g `o0' "  " %9.0g `o1' in gr "   `note'"
}
global S_1 `chi2'
global S_2
global S_3
global S_4
global S_5
global S_6
global S_7
global S_8
global S_9 `o'
global S_10 `o0'
global S_11 `o1'
global S_15 `pd'
global S_16 `pd0'
global S_17 `pd1'
global S_18 `pr'
global S_19 `pr0'
global S_20 `pr1'
global S_21 `pe'
global S_22 `pe0'
global S_23 `pe1'
end
