*! version 3.1.3  PR 28Nov96.
program define p1zi /* based on cii.ado and bitesti.ado */
	version 3.1
	local options "XName(string) CC EXAct Level(integer $S_level)"
	parse "`*'", parse(" ,")
	local 1=`1'
	confirm integer number `1'
	local n `1'
	mac shift
	local 1=`1'
	confirm integer number `1'
	local k `1'
	mac shift /* for p */
	if `n'<2 { error 2001 } 
	if `k'< 0 | `k'>`n' { 
		di in red "number of successes invalid"
		exit 450
	}
/*
disabled: would allow #successes to be a fraction, interpreted as obs p.
	capture conf integer num `k'
	if _rc { local k = int(`k'*`n' + .5) }
*/
	local p = `1'
	confirm number `p'
	if (`p'<=0 | `p'>=1) { 
		di in red "target proportion (p) invalid"
		exit 450
	}
	if !(substr("`1'",1,1)=="," | "`1'"=="") { mac shift }
	parse "`*'"
	if "`xname'"=="" { local xname "[N/A]" }
	if `level'<10 | `level'>99 { 
		error 198
	}
	local ttl "   Prop."
	local tt1 " Obs. N "

	if "`exact'"!="" {
		qui bitesti `n' `k' `p'
		local pexact $S_3	/* was $S_7 in Stata 4.0 */
	}
	di
	local obsp = `k'/`n'
	local expk = `p'*`n'
	global S_1 `n'
	global S_2 `p'
	global S_3 `obsp'
	global S_4 = sqrt(($S_3)*(1-$S_3)/`n') /* se based on obsp */
	local invn = invnorm((100+`level')/200) 
	global S_5 = $S_3 - `invn'*$S_4
	global S_6 = $S_3 + `invn'*$S_4

* Allow for continuity correction in hypothesis test (not in CI)

	if "`cc'"=="" {
		local chi2 = (`obsp'-`p')^2/(`p'*(1-`p')/`n')
		local cc "    "
	}
	else {
		local chi2 = (abs(`obsp'-`p')-1/(2*`n'))^2/(`p'*(1-`p')/`n')
		local cc "(CC)"
	}
	local z = sign(`obsp'-`p')*sqrt(`chi2')
	local P = chiprob(1,`chi2')
	global S_7 `z'
	global S_8 `P'

	local skip = 9 - length("`xname'") 
	#delimit ;
	di in gr
"Variable | `tt1'    `ttl'    Std. Err.       [`level'% Conf. Interval]" 
	_n "---------+" _dup(61) "-" ;

	di in gr _col(`skip') "`xname' |"
		in yel %8.0f $S_1 
	 	_col(23) %9.0g $S_3
	 	_col(35) %9.0g $S_4
	 	_col(51) %9.0g $S_5
	 	_col(63) %9.0g $S_6 ;
	di _n in gr 
"Variable |  Obs. k     Exp. k      Assumed p    Obs. p  `cc' SND   Pr>|SND|"
	_n "---------+" _dup(65) "-" _n
	_col(`skip') "`xname' |" in ye 
		%8.0f `k' "  " %9.0g `expk'
		"   " %11.5f $S_2 %11.5f $S_3
		"  " %8.3f $S_7 %11.4f $S_8 ;
	#delimit cr
	if "`exact'"!="" {
		di _n in gr /*
*/ "P-value (from \`exact' test) = " in ye %7.4f `pexact'
	}

end
