*! version 3.1.0  PR 11Mar1999.
program define p2zi /* based on csi.ado */
	version 6

	gettoken a 0 : 0, parse(" ,") 
	gettoken b 0 : 0, parse(" ,") 
	gettoken c 0 : 0, parse(" ,") 
	gettoken d 0 : 0, parse(" ,") 

	confirm integer number `a'
	confirm integer number `b'
	confirm integer number `c'
	confirm integer number `d'

	if `a'<0 | `b'<0 | `c'<0 | `d'<0 { 
		di in red "negative numbers invalid"
		exit 498
	}

	syntax [, Exact Level(integer $S_level) COL(string) OR Woolf TB /*
	 */ CC EXTra ]
	di

	if "`cc'"!="" & "`exact'"!="" {
		di in red "cc invalid with exact"
		exit 498
	}
	if `level'<10 | `level'>99 { local level 95 }
	local m1=`a'+`b'
	local m0=`c'+`d'
	local n1=`a'+`c'
	local n0=`b'+`d'
	local t=`n1'+`n0'

*	_crc4fld `a' `b' `c' `d' "`col'" "" Exposed Unexposed Cases Noncases
	_crc4fld `a' `b' `c' `d' "`col'" "" "Group A" "Group B" "Positive" "Negative"
	#delimit ; 
	di in gr _col(18) "|" _col(43) "|" ;

	di in gr "  Prop. positive | " in ye %9.0g `a'/`n1' "   " %9.0g `b'/`n0'
				in gr "  | " in ye %9.0g `m1'/`t' _n 
		in gr _col(18) "|" _col(43) "|" ;

	di in gr _col(18)
		"|         Pt. Est.       |  [`level'% Conf. Interval]" _n
		_col(18) "|" _dup(24) "-" "+" _dup(22) "-" ;

	_crcrd `a' `b' `c' `d' `level' `tb' ;
	local rd=r(rd) ;
	local rd0=r(lb) ;
	local rd1=r(ub) ;
	di in gr "  Diff. in props | " in ye
		_col(27) %9.0g `rd' in gr _col(43) "| "
		in ye %9.0g `rd0' "   " %9.0g `rd1' in gr "  `r(label)'" ;
	#delimit cr

	if "`extra'"!="" {
	  _crcrr `a' `b' `c' `d' `level' `tb'
	  local rr=r(rr)
	  local rr0=r(lb)
	  local rr1=r(ub)
	  local how `r(label)'
	  #delimit ;
	  di in gr "  Ratio of props | " in ye
		_col(27) %9.0g `rr' in gr _col(43) "| "
		in ye %9.0g `rr0' "   " %9.0g `rr1' in gr "  `how'" ;
	  #delimit cr

	  if `rr'>=1 {
		local afe = cond(`b'==0 & `a'>0,1,(`rr'-1)/`rr')
		local afe0=(`rr0'-1)/`rr0'
		local afe1=(`rr1'-1)/`rr1'
		local afp=(`a'/`m1')*`afe'
		local hdr " Attr. frac."
	  }
	  else {
	  	local hdr " Prev. frac."
	  	local afe=1-`rr'
	  	local afe0=1-`rr1'
	  	local afe1=1-`rr0'
	  	local afp=(`n1'/`t')*`afe'
	  }
	  di in gr "`hdr' ex. | " in ye /*
		*/ _col(27) %9.0g `afe' in gr _col(43) "| " /*
		*/ in ye %9.0g `afe0' "   " %9.0g `afe1' in gr "  `how'" _n /*
		*/ "`hdr' pop | " in ye /*
		*/ _col(27) %9.0g `afp' in gr _col(43) "|"

	  if "`or'"!="" {
		_crcor `a' `b' `c' `d' `level' `woolf' `tb'
		local r=r(nf)
		local r0=r(lb)
		local r1=r(ub)
		di in gr "      Odds ratio | " in ye /*
		*/ _col(27) %9.0g `r' in gr _col(43) "| " /* 
		*/ in ye %9.0g `r0' "   " %9.0g `r1' in gr "  `r(label)'"
	  }
	} /* end of "extra" */

	if "`exact'"=="" {
		_jprch22 `a' `b' `c' `d' "`cc'"	/* sets S_1 */
		global S_2=chiprob(1,$S_1)
		local z = sign(`rd')*sqrt($S_1)
		if "`cc'"!="" { local cc "  (with continuity correction)" }
		di in gr _col(18) "+" _dup(47) "-" _n /*
		*/ _col(18) "SND =" in ye %13.4f `z' in gr /*
		*/ _col(50) "Pr>|SND|=" in ye %7.4f $S_2 _n in gr /*
		*/ _col(18) "Chi2(1)`cc' =" /*
		*/ in ye %9.3f $S_1
	}
	else {
		quietly tabi `a' `b' \ `c' `d', exact
/*
	Translated r() returns from Stata 5 and 6 manual entries for -tabulate-
*/
		global S_1=r(p1_exact)
		global S_2=r(p_exact)
		di in gr _col(18) "+" _dup(47) "-" _n /*
		*/ _col(34) "1-tail Fisher's exact P =" in ye %7.4f $S_1 _n /*
		*/ in gr _col(34) "2-tail Fisher's exact P =" /*
		*/ in ye %7.4f $S_2
	}
	global S_3 `rd'
	global S_4 `rd0'
	global S_5 `rd1'
	global S_6 `rr'
	global S_7 `rr0'
	global S_8 `rr1'
	global S_9 `r'
	global S_10 `r0'
	global S_11 `r1'
	global S_12 `afe'
	global S_13 `afe0'
	global S_14 `afe1'
	global S_24 `afp'
end

* _crcchi2 with Yates-correction option, updated 10Oct97.
program define _jprch22 /* a b c d "yates" */ 
local a `1'
local b `2'
local c `3'
local d `4'
local yates "`5'"

tempname r1 r2 n1 n2 n p1 p2 diff p sediff cc z
scalar `r1'=`a'
scalar `r2'=`c'
scalar `n1'=`a'+`b'
scalar `n2'=`c'+`d'
scalar `n'=`n1'+`n2'
scalar `p1'=`r1'/`n1'
scalar `p2'=`r2'/`n2'
scalar `diff'=abs(`p1'-`p2')
scalar `p'=(`r1'+`r2')/`n'
* sediff is standard error of difference in proportions
* under null hypothesis of no difference (Altman 1991 p. 234)
scalar `sediff'=sqrt(`p'*(1-`p')*(1/`n1'+1/`n2'))
if "`yates'"!="" { scalar `cc'=0.5*(1/`n1'+1/`n2') }
else scalar `cc'=0

* must prevent z being negative---makes no sense.
scalar `z'=max(0,(`diff'-`cc'))/`sediff'
global S_1=`z'^2
end
