*! version 1.1.1 PR 29Mar96.
program define ptrend /* chisq for trend */
	version 4.0
	local varlist "req ex min(3) max(4)"
	local if "opt"
	local in "opt"
	local options "*"
	parse "`*'"
	parse "`varlist'", parse(" ")
	local r `1'
	local nr `2'
	local x `3'
	local p `4'
	tempvar n pr touse
	quietly {
		mark `touse' `if' `in'
		markout `touse' `r' `nr' `x' `p' /* Note: `p' could be null */
		count if `touse'
		local rows = _result(1)
                if `rows'<2 { exit 2001 }
		local r1 = `rows'-1
		gen long `n' = `r'+`nr' if `touse'
		if "`p'"=="" {
			local p "_prop"
			cap drop `p'
			gen `p' = `r'/`n'
			format `p' %8.3f
		}
/*
	Do regression for trend using binomial weights n for p = r/n.
	R = sum(r), N = sum(n) = sum(weights), P = R/N.

	Formula for chisq for trend adapted from that in TREND.MTB, needing
	some careful algebra and calculation of the weighted SSQ of x.
*/
		sum `r' if `touse'
		local R = _result(3)*`rows'
		sum `n'
		local N = _result(3)*`rows'
		local P = `R'/`N'
		sum `x' if `touse' [weight=`n']
		local ssx = `N'*_result(4)*(`r1')/`rows'
		reg `p' `x' [weight=`n']
		local b2 = _b[`x']^2
		local chitr = `b2'*`ssx'/(`P'*(1-`P'))
		local se = sqrt(`b2'/`chitr')
/*
	Ordinary chisquare
*/
		gen `pr' = sum(`p'*`r')
		local chisq = (`pr'[_N]-`R'*`P')/(`P'*(1-`P'))
		local chidep = `chisq' - `chitr'
		local dfdep = `rows'-2
	}
	list `r' `nr' `p' `x' if `touse'
	#delimit ;
	di in gr _n "Trend analysis for proportions" _n _dup(30) "-" _n ;
	di in gr "Regression of p = " in ye "`r'" in gr "/("
	 in ye "`r'" in gr "+"
	 in ye "`nr'" in gr ") on " in ye "`x'" in gr ":" ;
	di in gr "Slope = " in ye %7.0g _b[`x']
	 in gr ", std. error = " in ye %7.0g `se'
	 in gr ", Z = " in ye %7.3f sqrt(`chitr') ;
	di in gr _n "Overall chi2(" in ye `rows'-1 in gr ") = " _col(25)
	 %7.3f in ye `chisq' in gr ",  pr>chi2 = "
	 %6.4f in ye chiprob(`r1', `chisq');
	di in gr "Chi2(" in ye 1 in gr ") for trend = " _col(25)
	 %7.3f in ye `chitr' in gr ",  pr>chi2 = "
	 %6.4f in ye chiprob(1, `chitr') ;
	di in gr "Chi2(" in ye `dfdep' in gr ") for departure = " _col(25)
	 %7.3f in ye `chidep' in gr ",  pr>chi2 = "
	 %6.4f in ye chiprob(`dfdep', `chidep') ;
	#delimit cr
end
