*! version 1.1.2 PR 29Mar96. ARB 19/11/98
program define ptrend2 /* chisq for trend on individual record data */
	version 5.0
	local varlist "req ex min(2) max(3)"
	local if "opt"
	local in "opt"
	local options "*"
	parse "`*'"
	parse "`varlist'", parse(" ")
	local r `1'
	local group `2'
        preserve
        if "`3'" == "" {
                tempname score          /* default scores of 1,2,3... */
                qui egen _score=group(`group')
                local score _score
        }
        else {
		local score `3'
        }

	tempvar pr touse
	quietly {
		mark `touse' `if' `in'
		markout `touse' `r' `group' `score'
		keep if `touse'
                collapse (sum) `r' (mean) `score' (count) _no=`r', by(`group')
		local rows = _N
                if `rows'<2 { exit 2001 }
		local r1 = `rows'-1
		local p "_prop"
		cap drop `p'
		gen `p' = `r'/_no
		format `p' %8.3f
/*
	Do regression for trend using binomial weights n for p = r/n.
	R = sum(r), N = sum(n) = sum(weights), P = R/N.

	Formula for chisq for trend adapted from that in TREND.MTB, needing
	some careful algebra and calculation of the weighted SSQ of x.
*/
		sum `r'
		local R = _result(3)*`rows'
		sum _no
		local N = _result(3)*`rows'
		local P = `R'/`N'
		sum `score' [weight=_no]
		local ssx = `N'*_result(4)*(`r1')/`rows'
		reg `p' `score' [weight=_no]
		local b2 = _b[`score']^2
		local chitr = `b2'*`ssx'/(`P'*(1-`P'))
		local se = sqrt(`b2'/`chitr')
/*
	Ordinary chisquare
*/
		gen `pr' = sum(`p'*`r')
		local chisq = (`pr'[_N]-`R'*`P')/(`P'*(1-`P'))
		local chidep = `chisq' - `chitr'
		local dfdep = `rows'-2
	}
	list `r' _no `p' `score'
	#delimit ;
	di in gr _n "Trend analysis for proportions" _n _dup(30) "-" _n ;
	di in gr "Regression of " in ye "_prop" in gr " = (" in ye "`r'" in gr "/"
	 in ye "_no" in gr ") on " in ye "`score'" in gr ":" ;
	di in gr "Slope = " in ye %7.0g _b[`score']
	 in gr ", std. error = " in ye %7.0g `se'
	 in gr ", Z = " in ye %7.3f sqrt(`chitr') ;
	di in gr _n "Overall chi2(" in ye `rows'-1 in gr ") = " _col(25)
	 %7.3f in ye `chisq' in gr ",  pr>chi2 = "
	 %6.4f in ye chiprob(`r1', `chisq');
	di in gr "Chi2(" in ye 1 in gr ") for trend = " _col(25)
	 %7.3f in ye `chitr' in gr ",  pr>chi2 = "
	 %6.4f in ye chiprob(1, `chitr') ;
	di in gr "Chi2(" in ye `dfdep' in gr ") for departure = " _col(25)
	 %7.3f in ye `chidep' in gr ",  pr>chi2 = "
	 %6.4f in ye chiprob(`dfdep', `chidep') ;
	#delimit cr
end
