*! version 1.0.1 20Jan99 PR.
program define samppdlg
	version 5.0

	precmd samppdlg

	global D_run "1"
	global D_sm1 "Sample size for 2 proportions"
	global D_sm4 "Proportions"
	global D_sm5 "Significance level"
	global D_sm6 "Power"
	global D_sm9 "Sample 1"
	global D_sm10 "Sample 2"

	window control static D_sm4 8 25 68 10
	window control static D_sm5 8 43 68 8
	window control static D_sm6 8 61 68 8
	window control static D_sm9 80 14 35 10
	window control static D_sm10 120 14 35 10

        * Proportions
	window control edit 80 25 29 10 D_prop1
	window control edit 120 25 29 10 D_prop2

	* Significance level and method
	window control edit 80 43 29 10 D_alpha
	window control edit 80 61 29 10 D_power

        * Buttons
      	window control button "Run"    20 90 30 16 D_bok
	window control button "Cancel" 65 90 30 16 D_bex
	window control button "Help"  110 90 30 16 D_bhl help

	global D_bhl "whelp samppdlg"
	global D_bok "noi s2pok"
	global D_bex "exit 3000"

       	if "$D_alpha"=="" {
		global D_alpha .05
	}
       	if "$D_power"=="" {
		global D_power .8
	}
	noi capture window dialog "Sample size for 2 proportions" . . 165 135
	if _rc>3000 {
		s2pok
	}
	global D_run
end

program define s2pok
	version 5.0
	errrange "$D_prop1" "Sample 1 proportion" 0 1 =
	errrange "$D_prop2" "Sample 2 proportion" 0 1 =
	errrange "$D_alpha" "Significance level" 0 1 =
	errrange "$D_power" "Power" 0 1 =
	if "$D_run" != "" {
		noi di in white "sampsi $D_prop1 $D_prop2, power($D_power) alpha($D_alpha)"
	}
	else {
		noi di in white
		noi di in white ". sampsi $D_prop1 $D_prop2, power($D_power) alpha($D_alpha)"
	}
	global D_run
	window push sampsi $D_prop1 $D_prop2, power($D_power) alpha($D_alpha)
	noi sampsi $D_prop1 $D_prop2, power($D_power) alpha($D_alpha)
end
