*! version 1.0.0  15sep98 arb
* CID for grouped data
program define cidgdlg
	version 5.0

	precmd cidgdlg
	global D_sm1 "Data variable"
	global D_sm2 "Group var. (2 groups)"
	global D_sm3 "Confidence level"

	getnv
	global D_sm5 "$S_1"
	getbv
	global D_sm6 "$S_1"

	window control static D_sm1  10 10 50 10
	window control ssimple D_sm5 10 20 56 60 D_var1

	window control static D_sm2  75 10 80 10
	window control ssimple D_sm6 85 20 56 60 D_var2

       	window control check "Unpaired data" 10 80 75 8 D_cb1
       	window control check "Unequal variances" 10 90 75 8 D_cb2
       	window control check "Difference in medians" 10 100 125 8 D_cb3

	window control static D_sm3 10 115 65 10
	window control edit 78 115 20 10 D_level

      	window control button "OK"       10 135 30 16 D_bok
	window control button "Cancel"   45 135 30 16 D_bex
	window control button "Help"     80 135 30 16 D_bhl help
	window control button "Example" 115 135 30 16 D_beg

	global D_bhl "whelp ciddlg"
	global D_beg "whelp cidsmp"
	global D_bok "noi ptt2gok"
	global D_bex "exit 3000"

	noi capture window dialog "CI for difference in means" . . 160 170
end

program define ptt2gok
	version 5.0
	if "$D_level" == "" { global D_level 95 }
	errnull "$D_var1" "A data variable"
	errnull "$D_var2" "A group variable"
	errvar "$D_var1 $D_var2"
	errrange "$D_level" "Confidence level" 10 99 "" int
       	if $D_cb1 == 1 {
		local opt "unpaired "
	}
       	if $D_cb2 == 1 {
                if $D_cb1 != 1 {
                        window stopbox stop "Unequal option only valid with unpaired data."
                }
		local opt "`opt'unequal "
	}
       	if $D_cb3 == 1 {
		local opt "`opt'median"
	}
	noi di in white "cid $D_var1, by($D_var2) `opt' level($D_level)"
	window push cid $D_var1, by($D_var2) `opt' level($D_level)
	noi cid $D_var1, by($D_var2) `opt' level($D_level)
        exit 3001
end
