*! version 1.0.0  22/01/01 arb
* Kaplan Meier survival curves
program define kmdlg
	version 6.0
	cap st_is 2 analysis	// check data is stset
	if _rc {
		window stopbox stop "You must set your data to survival time first. Please see the Data menu."
	}
	global D_dot
	global D_sm1 "Group variable (optional)"
	window control static D_sm1 5 5 90 15 left
	window control ssimple D_vl 5 20 70 60 D_var1
	window control check "Log-rank test" 5 80 70 9 D_cb1
	window control check "Show CIs" 5 90 70 9 D_cb2
	window control check "Y axis as-is" 5 100 70 9 D_cb3
	xi
	getnv
	global D_vl "$S_1"
	global D_sm3 "Is group variable:"
	window control static D_sm3 80 20 70 9 left
	window control radbegin "categorical" 80 30 50 9 D_rb1
	window control radend "continuous" 80 40 50 9 D_rb1
	global D_sm4 "If continuous, number of groups:"
	window control static D_sm4 80 50 70 14 left
	window control edit 80 70 15 7 D_bins
	window control button "-" 100 70 12 9 D_b1
	window control button "+" 112 70 12 9 D_b2
	window control button "Draw"   10 140 30 16 D_b7
	window control button "OK"	   45 140 30 16 D_b4
	window control button "Cancel" 80 140 30 16 D_b5
	window control button "Help"  115 140 30 16 D_b6 help
	if "$D_bins"=="" { global D_bins 3 }
	global D_b1 "kmbin -1"
	global D_b2 "kmbin 1"
	global D_b7 "noi kmok"
	global D_b4 "noi kmok exit"
	global D_b5 "exit 3000"
	global D_b6 "whelp kmdlg"
	cap noi window dialog "Kaplan Meier graph" . . 160 175
end

program define kmok
	version 6.0
	local exit `1'
	local wc1: word count $D_var1
	if `wc1'>0 {
		errvar "$D_var1"	// check variables exist
		local by "by($D_var1) "
	}
	local anvar $D_var1
	if $D_cb2 { local ci "gwood" }
	if $D_cb3 { local ya "yasis " }
	if $D_rb1==2 & "$D_bins"!="" & `wc1'>0 {
		errrange "$D_bins" "Number of bins" 2 100 "" int
		qui inspect $D_var1
		if _result(7)<$D_bins {
			window stopbox stop "You have specified more bins than there are unique values of $D_var1"
		}
		tempvar grpv
		di in wh "${D_dot}xtile `grpv'=$D_var1, n($D_bins)"
		global D_dot ". "
		window push xtile `grpv'=$D_var1, n($D_bins)
		qui xtile `grpv'=$D_var1, n($D_bins)
		local by "by(`grpv') t1(`"Kaplan-Meier survival estimates, by $D_bins quantiles of $D_var1"')"
		local i 1
		qui sum `grpv'
		local ngs=r(max)
		cap label drop _grpv
		while `i'<=`ngs' {
			qui sum $D_var1 if `grpv'==`i'
			local lo : display %3.2f `r(min)'
			local hi : display %3.2f `r(max)'
			label define _grpv `i' "`lo' - `hi'", add
			local i=`i'+1
		}
		label values `grpv' _grpv
		label variable `grpv' "$D_var1"
		local anvar `grpv'
*		local tr ,trend		// Stata 7 only
	}
	di in wh `"${D_dot}sts graph, `by'`ya'`ci'"'
	window push sts graph, `by'`ya'`ci'
	sts graph, `by'`ya'`ci'
	global D_dot ". "
	if $D_cb1 & `wc1'>0 {
		set more off
		* Note add `tr' to end of next 3 cmds for Stata 7 trend test
		di in wh `"${D_dot}sts test `anvar'"'
		window push sts test `anvar'
		sts test `anvar'
		set more on
	}
	if "`exit'"=="exit" {exit 3000}
end

program define kmbin
	global D_bins = $D_bins + `1'
	if $D_bins<1 { global D_bins 1 }
	global D_rb1 2
end

