*! version 1.0.0  22/1/01 arb
* stcox dialog
program define mcoxdlg
	version 6.0
	cap st_is 2 analysis	// check data is stset
	if _rc {
		window stopbox stop "You must set your data to survival time first. Please see the Data menu."
	}
	if "$D_cmd" != "mcoxdlg" {
		local flag 1
	}
	precmd mcoxdlg
	set more off
	if "`flag'"!="" {
		global D_cb1 = 1
	}
	global D_vart : char _dta[st_bt]
	global D_vard : char _dta[st_bd]
	xi
	global D_sm1 "Survival time: $D_vart"
	global D_sm6 "Failure indicator: $D_vard"
	global D_sm2 "Independent variables:"
	global D_sm3 "Continuous"
	global D_sm4 "Categorical"
	global D_sm5 "Report hazard ratios for continuous variables:"
	window control static D_sm1 5 30 75 8 left
	window control static D_sm6 5 40 75 16 left
	window control static D_sm2 85 5 75 8 left
	window control static D_sm3 85 15 75 8 left
	window control msimple D_vl 85 25 125 60 D_var2
	window control static D_sm4 215 15 75 8 left
	window control msimple D_vl 215 25 125 60 D_var3
	getnv
	global D_vl "$S_1"
	window control static D_sm5 15 86 80 18 left
	window control radbegin "per unit" 90 90 35 9 D_rb1
	window control radend "per standard deviation" 130 90 100 9 D_rb1
	window control check "Show diagnostics menu" 240 90 90 9 D_cb1
	window control button "OK"	   102 105 30 16 D_b4
	window control button "Cancel" 140 105 30 16 D_b5
	window control button "Help"   178 105 30 16 D_b6 help
	window control button "Example" 216 105 30 16 D_b7
	global D_b4 "noi coxok"
	global D_b5 "exit 3000"
	global D_b6 "whelp mcoxdlg"
	global D_b7 "whelp mcoxsmp"
	cap noi window dialog "Multiple Cox regression" . . 350 140
	if _rc==3001 {
		if "$D_var3"!="" {
			local xi xi:
			parse "$D_var3", parse(" ")
			while "`1'"!="" {
				local catvar "`catvar'i.`1' "
				mac shift
			}
		}
		if $D_rb1==2 { local sd sd }
		cap drop _sca*
		cap drop _sch*
		global D_ocmd "qui `xi'stcox $D_var2 `catvar', scaledsch(_sca*) schoenfeld(_sch*)"
		di in wh "$D_ocmd"
		window push $D_ocmd
		$D_ocmd
		global D_np = _result(3)+1  /* No of parameters in the model */
		di in wh ". reformat, n nose eform `sd'"
		window push reformat, n nose eform `sd'
		reformat, n nose eform `sd'
		if $D_cb1 {
			di in wh ". lrtest, saving(0)"
			window push lrtest, saving(0)
			lrtest, saving(0)
			di in wh ". predict __cox"
			window push predict __cox
			predict __cox
			postdlg
		}
		disp in wh ". xi"
		window push xi
		xi
	}
	cap drop _sch*
	cap drop _sca*
	set more on
end

program define coxok
	version 6.0
	if trim("$D_var2$D_var3")=="" {
		window stopbox stop "Please specify at least one independent variable"
	}
	errvar "$D_var2 $D_var3"
	exit 3001
end

program define postdlg
	version 6.0
	window control radbegin "Likelihood-ratio test of:" 10 10 110 9 D_rb2
	window control radio "Log-log plot of:" 10 35 100 9 D_rb2
	window control radend "Proportion hazards test" 10 60 100 9 D_rb2
	window control scombo D_evl 30 20 50 60 D_lrv
	window control scombo D_cvl 30 45 50 60 D_llv
	global D_evl
	parse "$D_var2 $D_var3", parse(" ")
	while "`1'"!="" {
		global D_evl "$D_evl`1' "
		mac shift
	}
	global D_evl=trim("$D_evl")
	global D_lrv: word 1 of $D_var3 $D_var2
	global D_llv: word 1 of $D_var3
	global D_cvl
	parse "$D_var3", parse(" ")
	while "`1'"!="" {
		global D_cvl "$D_cvl`1' "
		mac shift
	}
	global D_cvl=trim("$D_cvl")
	window control button "Run" 10 80 30 16 D_b1
	window control button "Cancel" 45 80 30 16 D_b2
	window control button "Help" 80 80 30 16 D_b3 help
	global D_b1 "noi postcmd"
	global D_b2 "exit 3000"
	global D_b3 "whelp pcoxmenu"
	cap noi window dialog "Post-cox diagnostics" . . 130 115
	di in wh ". drop __cox"
	window push drop __cox
	drop __cox
	cap drop _sch*
	cap drop _sca*
	set more on
end

program define postcmd
	version 6.0
	if $D_rb2==1 {
		* LR test
		errvar "$D_lrv"	// check variable exists
		estimates hold orig
		parse "$D_var2", parse(" ")
		while "`1'"!="" {
			if "`1'"!="$D_lrv" {
				local convar "`convar'`1' "
			}
			mac shift
		}
		parse "$D_var3", parse(" ")
		while "`1'"!="" {
			if "`1'"!="$D_lrv" {
				local xi xi:
				local catvar "`catvar'i.`1' "
			}
			mac shift
		}
		di in wh ". qui `xi'stcox `convar' `catvar' if __cox!=."
		window push qui `xi'stcox `convar' `catvar' if __cox!=.
		qui `xi'stcox `convar' `catvar' if __cox!=.
		di in wh ". lrtest"
		local varlab : variable label $D_lrv
		di in ye "$D_lrv  " in gr "`varlab'"
		window push lrtest
		lrtest
		estimates unhold orig
	}
	else if $D_rb2==2 {
		* Log-log plot
		errvar "$D_llv"	// check variable exists
		estimates hold orig
		parse "$D_var2 $D_var3", parse(" ")
		while "`1'"!="" {
			if "`1'"!="$D_llv" {
				local advars "`advars'`1' "
			}
			mac shift
		}
		local advars=trim("`advars'")
		global D_ocmd "stphplot, strata($D_llv)"
		if !missing("`advars'") {
			global D_ocmd "stphplot, strata($D_llv) adjust(`advars')"
		}
		else {
			global D_ocmd "stphplot, by($D_llv)"
		}
		di in wh ". $D_ocmd"
		window push $D_ocmd
		$D_ocmd
		estimates unhold orig
	}
	else if $D_rb2==3 {
		* PH test
		global D_ocmd "stphtest, detail"
		di in wh ". $D_ocmd"
		window push $D_ocmd
		$D_ocmd
	}
end
