*! version 1.0.0  22/12/98 arb
program define mlogdlg
	version 5.0
	if "$D_cmd" != "mlogdlg" {
		local flag 1
	}
	precmd mlogdlg
	if "`flag'"!="" {
		global D_cb1 = 1
	}
        xi

	global D_sm1 "Dependent variable (must be binary 0/1)"
	global D_sm2 "Independent variables:"
	global D_sm3 "Continuous"
	global D_sm4 "Categorical"
        global D_sm5 "Report odds ratios for continuous variables:"
	window control static D_sm1 5 9 75 16 left
	window control ssimple D_ol 5 25 75 60 D_var1
	window control static D_sm2 85 5 75 8 left
	window control static D_sm3 85 15 75 8 left
	window control msimple D_vl 85 25 125 60 D_var2
	window control static D_sm4 215 15 75 8 left
	window control msimple D_vl 215 25 125 60 D_var3
        getbv, zero
        global D_ol "$S_1"
	getnv
	global D_vl "$S_1"
        window control static D_sm5 20 86 68 18 left
        window control radbegin "per unit" 90 90 35 9 D_rb1
        window control radend "per standard deviation" 130 90 100 9 D_rb1
        window control check "Show diagnostics menu" 240 90 90 9 D_cb1
	window control button "OK"     102 105 30 16 D_b4
	window control button "Cancel" 140 105 30 16 D_b5
	window control button "Help"   178 105 30 16 D_b6 help
        window control button "Example" 216 105 30 16 D_b7
	global D_b4 "noi logiok"
	global D_b5 "exit 3000"
	global D_b6 "whelp mlogdlg"
        global D_b7 "whelp mlogsmp"
	cap noi window dialog "Multiple logistic regression" . . 350 140
        if _rc==3001 {
                if "$D_var3"!="" {
                        local xi xi:
                        parse "$D_var3", parse(" ")
                        while "`1'"!="" {
                                local catvar "`catvar'i.`1' "
                                mac shift
                        }
                }
		if $D_rb1==2 { local sd sd }
                global D_ocmd "qui `xi'logistic $D_var1 $D_var2 `catvar'"
                di in wh "$D_ocmd"
                window push $D_ocmd
                $D_ocmd
		global D_np = _result(3)+1	/* No of parameters in the model */
                di in wh ". reformat, n nose `sd'"
                window push reformat, n nose `sd'
                reformat, n nose `sd'
                if $D_cb1 {
                        di in wh ". lrtest, saving(0)"
                        window push lrtest, saving(0)
                        lrtest, saving(0)
                        di in wh ". lpredict __phat"
                        window push lpredict __phat
                        lpredict __phat
                        postdlg
                }
		disp in wh ". xi"
		window push xi
		xi
        }
end

program define logiok
	version 5.0
	local wc1: word count $D_var1
	if `wc1'!=1 {
		window stopbox stop "Please specify one dependent variable"
	}
	errvar "$D_var1 $D_var2 $D_var3"
        parse "$D_ol", parse(" ")
        local flag 1
        while "`1'"!="" {
        	if "`1'"=="$D_var1" {
                        local flag 0
                }
                mac shift
        }
        if `flag' {
                window stopbox stop "Dependent variable is not binary (0/1)"
        }
	cap confirm string var $D_var1
	if !_rc {
		window stopbox stop "$D_var1 is a string variable." /*
			*/ "Please use only a numeric outcome variable."
	}
        if trim("$D_var2$D_var3")=="" {
                window stopbox stop "Please specify at least one independent variable"
        }
        exit 3001
end

program define postdlg
        version 5.0
        window control radbegin "Likelihood-ratio test of:" 10 10 110 9 D_rb2
        window control radend "Hosmer-Lemeshow test" 10 35 100 9 D_rb2
        window control scombo D_evl 30 20 50 60 D_lrv
        global D_evl
	parse "$D_var2 $D_var3", parse(" ")
        while "`1'"!="" {
                global D_evl "$D_evl`1' "
                mac shift
        }
        global D_evl=trim("$D_evl")
        local lrv: word 1 of $D_var3 $D_var2
        global D_lrv `lrv'
       	window control button "Run" 10 70 30 16 D_b1
	window control button "Cancel" 45 70 30 16 D_b2
	window control button "Help" 80 70 30 16 D_b3 help
	global D_b1 "noi postcmd"
	global D_b2 "exit 3000"
	global D_b3 "whelp plogmenu"
	cap noi window dialog "Post-logistic diagnostics" . . 130 105
        di in wh ". drop __phat"
        window push drop __phat
        drop __phat
end

program define postcmd
        version 5.0
        if $D_rb2==1 {
                parse "$D_var2", parse(" ")
                while "`1'"!="" {
                        if "`1'"!="$D_lrv" {
                                local convar "`convar'`1' "
                        }
                        mac shift
                }
                parse "$D_var3", parse(" ")
                while "`1'"!="" {
                        if "`1'"!="$D_lrv" {
                                local xi xi:
                                local catvar "`catvar'i.`1' "
                        }
                        mac shift
                }
                di in wh ". qui `xi'logistic $D_var1 `convar' `catvar' if __phat!=."
                window push qui `xi'logistic $D_var1 `convar' `catvar' if __phat!=.
                qui `xi'logistic $D_var1 `convar' `catvar' if __phat!=.
                di in wh ". lrtest"
                local varlab : variable label $D_lrv
                di in ye "$D_lrv  " in gr "`varlab'"
                window push lrtest
                lrtest
        }
        else if $D_rb2==2 {
                di in wh ". $D_ocmd"
                window push $D_ocmd
                $D_ocmd
		local G 10
		if $D_np + 1 >= `G' { local G = $D_np + 2 }
                di in wh ". lfit, group(`G')"
                window push lfit, group(`G')
                lfit, group(`G')
        }
end
