*! version 1.0.1  30Oct98 arb/PR.
program define p2zidlg
	version 5.0

	precmd p2zidlg

	global D_run "1"
	global D_sm1 "2-sample test of proportions"
	global D_sm4 "No. of observations"
	global D_sm5 "No. of successes or"
	global D_sm6 "observed proportion"
	global D_sm7 "Confidence level"
	global D_sm9 "Sample 1"
	global D_sm10 "Sample 2"

	window control static D_sm4 8 25 68 10
	window control static D_sm5 8 38 68 8
	window control static D_sm6 8 46 68 8
	window control static D_sm9 80 14 35 10
	window control static D_sm10 120 14 35 10
	window control static D_sm7 8 61 68 10

        * Number of observations
	window control edit 80 25 29 10 D_nobs1
	window control edit 120 25 29 10 D_nobs2

        * Number of successes
	window control edit 80 40 29 10 D_succ1
	window control edit 120 40 29 10 D_succ2

	* Significance level and method
        window control edit 80 61 20 10 D_level
        window control radbegin "Unadjusted" 50 75 120 10 D_meth
        window control radio "Continuity correction" 50 85 120 10 D_meth
        window control radend "Exact" 50 95 120 10 D_meth

        * Buttons
      	window control button "Run"    20 112 30 16 D_bok
	window control button "Cancel" 65 112 30 16 D_bex
	window control button "Help"  110 112 30 16 D_bhl help

	global D_bhl "whelp p2zidlg"
	global D_bok "noi tp2ok"
	global D_bex "exit 3000"

       	if "$D_level"=="" {
		global D_level 95
	}
	noi capture window dialog "2-sample test of proportions" . . 165 150
	if _rc>3000 {
		tp2ok
	}
	global D_run
end

program define tp2ok
	version 5.0
	local a "No. of obs."
	local b "sample"
	local p "No. of successes"
	errrange "$D_nobs1" "`a', `b' 1" 0 .
	errrange "$D_nobs2" "`a', `b' 2" 0 .
	errrange "$D_succ1" "`p', `b' 1" 0 $D_nobs1
	errrange "$D_succ2" "`p', `b' 2" 0 $D_nobs2
	errrange "$D_level" "Confidence level" 10 99

        if $D_succ1 < 1 {
		global D_succ1 = round($D_succ1*$D_nobs1,1)
	}
        if $D_succ2 < 1 {
		global D_succ2 = round($D_succ2*$D_nobs2,1)
	}
        global D_fail1 = $D_nobs1-$D_succ1
        global D_fail2 = $D_nobs2-$D_succ2
        if $D_meth == 2 {
                local opt cc
        }
        else if $D_meth == 3 {
                local opt exact
        }
	if "$D_run" != "" {
		noi di in white "p2zi $D_succ1 $D_succ2 $D_fail1 $D_fail2, level($D_level) `opt'"
	}
	else {
		noi di in white
		noi di in white ". p2zi $D_succ1 $D_succ2 $D_fail1 $D_fail2, level($D_level) `opt'"
	}
	global D_run
	window push p2zi $D_succ1 $D_succ2 $D_fail1 $D_fail2, level($D_level) `opt'
	noi p2zi $D_succ1 $D_succ2 $D_fail1 $D_fail2, level($D_level) `opt'
end
