*! version 1.0.1  25/1/99 arb
program define pgradlg
	version 5.0
        global D_dot
	global D_sm1 "Y-axis variable (must be binary)"
	global D_sm2 "X-axis variable"
        global D_sm3 "Is X-axis variable:"
        global D_sm4 "If continuous, number of groups:"
	window control static D_sm1 5 5 60 15 left
	window control ssimple D_ol 5 20 70 60 D_var1
	window control static D_sm2 80 5 70 8 left
	window control ssimple D_vl 80 20 70 60 D_var2
        xi
        getbv
        global D_ol "$S_1"
	getnv
	global D_vl "$S_1"
        window control static D_sm3 80 82 70 9 left
        window control radbegin "categorical" 80 90 50 9 D_rb1
        window control radend "continuous" 80 100 50 9 D_rb1
        window control check "Plot on logit scale" 5 80 70 9 D_cb1
        window control check "Show C.I." 5 90 70 9 D_cb2
        window control static D_sm4 80 110 70 14 left
        window control edit 80 125 15 7 D_bins
        window control button "-" 100 125 12 9 D_b1
        window control button "+" 112 125 12 9 D_b2
        window control button "Draw"   10 140 30 16 D_b7
	window control button "OK"     45 140 30 16 D_b4
	window control button "Cancel" 80 140 30 16 D_b5
	window control button "Help"  115 140 30 16 D_b6 help
        if "$D_bins"=="" { global D_bins 10 }
	global D_b1 "pgrabin -1"
	global D_b2 "pgrabin 1"
	global D_b7 "noi pgraok"
	global D_b4 "noi pgraok exit"
	global D_b5 "exit 3000"
	global D_b6 "whelp pgradlg"
	cap noi window dialog "Graph proportions" . . 160 175
end

program define pgraok
	version 5.0
        local exit `1'
	local wc1: word count $D_var1
	if `wc1'!=1 {
		window stopbox stop "Please specify one Y-axis variable"
	}
	errvar "$D_var1 $D_var2"
        parse "$D_ol", parse(" ")
        local flag 1
        while "`1'"!="" {
        	if "`1'"=="$D_var1" {
                        local flag 0
                }
                mac shift
        }
        if `flag' {
                window stopbox stop "Dependent variable is not binary"
        }
	cap confirm string var $D_var1
	if !_rc {
		window stopbox stop "$D_var1 is a string variable." /*
			*/ "Please use only a numeric outcome variable."
	}
        if trim("$D_var2")=="" {
                window stopbox stop "Please specify one X-axis variable"
        }
        local xlall xlall
        if $D_cb1 { local logit " logit" }
        if $D_cb2 { local ci " ci" }
        if $D_rb1==2 & "$D_bins"!="" {
                errrange "$D_bins" "Number of bins" 2 100 "" int
                qui inspect $D_var2
                if _result(7)<$D_bins {
                        window stopbox stop "You have specified more bins than there are unique values of $D_var2"
                }
                if $D_bins>25 { local xlall xlab }
                local bin " bin($D_bins)"
        }
        else if $D_rb1==1 {
                qui inspect $D_var2
                if _result(7) > 25 {
                        local xlall xlab
                }
		local con " c(.II)"
        }
        di in wh "${D_dot}pgraph $D_var1 $D_var2, `xlall' ylab`logit'`ci'`con'`bin'"
        window push pgraph $D_var1 $D_var2, `xlall' ylab`logit'`ci'`con'`bin'
        pgraph $D_var1 $D_var2, `xlall' ylab`logit'`ci'`con'`bin'
        global D_dot ". "
        if "`exit'"=="exit" {exit 3000}
end

program define pgrabin
	global D_bins = $D_bins + `1'
	if $D_bins<1 { global D_bins 1 }
	global D_rb1 2
end

