*! version 1.2.0  22jan01 arb/pr
* Set up Stata for StataQuest and PSMR menus
* Survival analysis commands added by ARB
program define psmr
	if "`1'"=="off" {
		window menu clear
		global S_PSMR
		di in gr "PSMR menus off.  The menubar has been changed."
		capture quest off
		exit
	}
	if "$S_PSMR" == "on" {
		di in bl "PSMR menus already enabled."
		exit
		}
	capture quest	/* sets up SQ menus and defines $qpath, and more */
	local rc=_rc
	if `rc'==199 {	/* quest.ado not on disk or not on adopath */
		di in red "I cannot find quest.ado, so I cannot proceed."
		di in red "Please install the StataQuest menu system according to the instructions."
		di in red "PSMR menus not enabled."
		exit 199
	}
	if `rc' {	/* !!fatal error within quest.ado, is this possible? */
		di in red "Some problem occurred with the StataQuest menu system, so I cannot proceed."
		di in red "Please ensure the StataQuest menu system is installed correctly."
		di in red "PSMR menus not enabled."
		capture quest off
		exit 198
	}
	quietly {
	global S_PSMR on
***************************************************************************
* Adding PSMR items marked by `psmrch' to StataQuest menus---currently, null.

*	local psmrch " "
	local psmrch

* Data
	local mname "Data"
	wmenu append separator "`mname'"
	wmenu append string "`mname'" "`psmrch'Extended generate" "egendlg"
	wmenu append string "`mname'" "`psmrch'Blocked randomisation" "branddlg"
	wmenu append string "`mname'" "`psmrch'Set data to survival time" "stdlg"

* Graphs
	local mname "Graphs"
	wmenu append separator "`mname'"

	wmenu append string "`mname'" "`psmrch'Dotplot" "dplotdlg"
	wmenu append string "`mname'" "`psmrch'Graph proportions" "pgradlg"
	wmenu append string "`mname'" "`psmrch'Ladder of transformations" "gladdlg"
	wmenu append string "`mname'" "`psmrch'Kaplan-Meier survival graph" "kmdlg"

* Summaries
	local mname "Summaries"
	wmenu append separator "`mname'"

	wmenu append string "`mname'" "`psmrch'CI for difference in means/medians" "ciddlg"
	wmenu append string "`mname'" "`psmrch'Centiles" "centdlg"
	wmenu append string "`mname'" "`psmrch'List survivor function" "stlidlg"

* Statistics
	local mname "Statistics"
	wmenu append separator "`mname'"

	wmenu append string "`mname'" "`psmrch'Chi-squared test of rxc table" "tchidlg"
	wmenu append string "`mname'" "`psmrch'Chi-squared test for trend" "ptrndlg"
	wmenu append string "`mname'" "`psmrch'Contrasts in ANOVA" "contrdlg"
	wmenu append string "`mname'" "`psmrch'Multiple logistic regression" "mlogdlg"
	wmenu append string "`mname'" "`psmrch'Normality test" "sfrandlg"
	wmenu append string "`mname'" "`psmrch'Cox regression" "mcoxdlg"

* Calculator
	local mname "Calculator"
	wmenu append separator "`mname'"

	wmenu append string "`mname'" "`psmrch'Evaluate an expression" "dispdlg"
	wmenu append string "`mname'" "`psmrch'Two independent proportions" "p2zidlg"
	wmenu append string "`mname'" "`psmrch'Two paired proportions" "mczidlg"
	wmenu append string "`mname'" "`psmrch'Sample size for 2 means" "sampmdlg"
	wmenu append string "`mname'" "`psmrch'Sample size for 2 proportions" "samppdlg"

* Help
	if "$S_OS" != "MacOS" {
		quietly query born
		if "$S_1" < "14263" {
			local mname "Help"
		}
		else {
			local mname "sHelp"
		}
	}

	wmenu append string "`mname'" "`psmrch'About PSMR" "psmrdlg"

	window menu set "StataQuest"
	}
	di in gr "PSMR menus enabled."
end
