*! version 1.0.1 20Jan99 PR.
program define sampmdlg
	version 5.0

	precmd sampmdlg

	global D_run "1"
	global D_sm1 "Sample size for 2 means"
	global D_sm4 "Means"
	global D_sm7 "Standard deviation"
	global D_sm5 "Significance level"
	global D_sm6 "Power"
	global D_sm9 "Sample 1"
	global D_sm10 "Sample 2"

	window control static D_sm4 8 25 68 10
	window control static D_sm7 8 43 68 10
	window control static D_sm5 8 61 68 8
	window control static D_sm6 8 79 68 8
	window control static D_sm9 80 14 35 10
	window control static D_sm10 120 14 35 10

        * Means and sd
	window control edit 80 25 29 10 D_mu1
	window control edit 120 25 29 10 D_mu2
	window control edit 80 43 29 10 D_sd

	* Significance level and method
	window control edit 80 61 29 10 D_alpha
	window control edit 80 79 29 10 D_power

        * Buttons
      	window control button "Run"    20 100 30 16 D_bok
	window control button "Cancel" 65 100 30 16 D_bex
	window control button "Help"  110 100 30 16 D_bhl help

	global D_bhl "whelp sampmdlg"
	global D_bok "noi s2mok"
	global D_bex "exit 3000"

       	if "$D_alpha"=="" {
		global D_alpha .05
	}
       	if "$D_power"=="" {
		global D_power .8
	}
	noi capture window dialog "Sample size for 2 means" . . 165 135
	if _rc>3000 {
		s2mok
	}
	global D_run
end

program define s2mok
	version 5.0
	errrange "$D_mu1" "Sample 1 mean" . .
	errrange "$D_mu2" "Sample 2 mean" . .
	errrange "$D_sd" "Standard deviation" 0 . =
	errrange "$D_alpha" "Significance level" 0 1 =
	errrange "$D_power" "Power" 0 1 =
	if "$D_run" != "" {
		noi di in white "sampsi $D_mu1 $D_mu2, power($D_power) alpha($D_alpha) sd($D_sd)"
	}
	else {
		noi di in white
		noi di in white ". sampsi $D_mu1 $D_mu2, power($D_power) alpha($D_alpha) sd($D_sd)"
	}
	global D_run
	window push sampsi $D_mu1 $D_mu2, power($D_power) alpha($D_alpha) sd($D_sd)
	noi sampsi $D_mu1 $D_mu2, power($D_power) alpha($D_alpha) sd($D_sd)
end
