*! version 1.0.1 PR 28Oct1998.
*  Based on sfrancia.ado.
program define sfranadj
	version 5.0
	local varlist "req ex"
	local if "opt"
	local in "opt"
	local options "Accountfor(str) Residuals Plot"
	parse "`*'"
	parse "`varlist'", parse(" ")
	if "`account'"!="" {
		unabbrev `account'
		local account $S_1
		tempvar resid
		local yvar `resid'
	}
	di
	if "`account'"!="" {
		di in gr " Shapiro-Francia W' test for normal data" /*
		 */ ", accounting for `account'"
	}
	else {
		di in gr _col(16) "Shapiro-Francia W' test for normal data"
	}
	di in gr " Variable |    Obs" _col(29) "W'" /*
	 */	_col(39) "V'" /*
	 */	_col(51) "z    Pr>z" _n /*
	 */	" ---------+" _dup(49) "-"
	tempvar WD1 touse
	mark `touse' `if' `in'
	markout `touse' `account'
	while "`1'"~="" { 
		quietly if "`account'"!="" {
			capture anova `1' `account' if `touse'
			local rc=_rc
			if `rc' {
				di in red "could not account for `account'"
				error `rc'
			}
			capture drop `resid'
			predict `resid' if `touse', resid
		}
		else local yvar `1'
/*
	Calculate ranks
*/
		capture drop `WD1'
		quietly genrank `WD1' = `yvar' if `touse'
/*
	Calculate number of good values
*/
		local skip = 9 - length("`1'") 
		quietly summarize `WD1'
		local G=_result(1)
		if _result(1)<5 { 
			local R . 
			local w . 
			local Z .
			local sig .
			global S_5 . 
		}
		else {
			quietly replace `WD1'=invnorm((`WD1'-0.375)/(`G'+0.25))
			quietly corr `yvar' `WD1'
			local X=log(`G')-5
			local L=-0.0480157+`X'*(0.01971964-0.0119065*`X'*`X')
			local M=-exp(1.6930674+`X'*(0.1441647 /*
				*/	+`X'*(-0.01849276  /*
				*/	+`X'*(0.031074485+`X'*0.0055717663))))
			local S=exp(-0.510725+`X'*(-0.1160364 /*
				*/	+`X'*(-0.006702098 /*
				*/ 	+`X'*(0.054465944+`X'*0.0087397329))))
			local Y=(((1-(_result(4))^2)^`L')-1)/`L'
			local Z=(`Y'-`M')/`S'
			local R=(_result(4))^2
			local w=(1-`R')/( (`L'*`M'+1)^(1/`L') )
			global S_5 = normprob(-`Z')
			local sig=max($S_5,.00001)
		}
		#delimit ;
		di in gr _skip(`skip') "`1' |" in ye
			%7.0f `G' "    "
			%8.5f `R' "  "
			%8.3f `w' "   "
			%8.3f `Z' "  "
			%7.5f `sig'
		;
		#delimit cr
		mac shift 
	}
	cap drop _resid
	if "`account'"=="" {
		qui sum `yvar' if `touse'
		qui gen _resid=`yvar'-_result(3)
	}
	else {
		rename `yvar' _resid
		local yvar _resid
	}
	lab var _resid "Residuals"
	if "`plot'"!="" {
		qnorm `yvar', xlabel ylabel
	}
	if "`residua'"=="" { cap drop _resid }
	global S_1 `G'		/* # observations		*/
	global S_2 `R'		/* W'				*/
	global S_3 `w'		/* V'				*/
	global S_4 `Z'		/* z				*/
	/* global S_5 */	/* P				*/
end
