*! version 1.0.0  24/01/01 arb
* sts list survival curves
program define stlidlg
	version 6.0
	cap st_is 2 analysis	// check data is stset
	if _rc {
		window stopbox stop "You must set your data to survival time first. Please see the Data menu."
	}
	global D_dot
	global D_sm1 "Group variable (optional)"
	global D_sm2 "Restrict list to these time-points:"
	window control static D_sm1 5 5 90 15 left
	window control ssimple D_vl 5 20 70 60 D_var1
	window control static D_sm2 5 90 150 9 left
	window control edit 5 100 80 7 D_at
	xi
	getnv
	global D_vl "$S_1"
	global D_sm3 "Is group variable:"
	window control static D_sm3 80 20 70 9 left
	window control radbegin "categorical" 80 30 50 9 D_rb1
	window control radend "continuous" 80 40 50 9 D_rb1
	global D_sm4 "If continuous, number of groups:"
	window control static D_sm4 80 50 70 14 left
	window control edit 80 70 15 7 D_bins
	window control button "-" 100 70 12 9 D_b1
	window control button "+" 112 70 12 9 D_b2
	window control button "OK"	   25 140 30 16 D_b4
	window control button "Cancel" 60 140 30 16 D_b5
	window control button "Help"   95 140 30 16 D_b6 help
	if "$D_bins"=="" { global D_bins 3 }
	global D_b1 "libin -1"
	global D_b2 "libin 1"
	global D_b4 "noi liok"
	global D_b5 "exit 3000"
	global D_b6 "whelp stlidlg"
	cap noi window dialog "List survivor function" . . 160 175
	if _rc==3001 {
		di in wh `"${D_dot}$D_ocmd"'
		window push $D_ocmd
		$D_ocmd
		cap drop __group
	}
end

program define liok
	version 6.0
	local wc1: word count $D_var1
	if `wc1'>0 {
		errvar "$D_var1"	// check variables exist
		local by "by($D_var1) "
	}
	if !missing("$D_at") {
		cap numlist "$D_at"
		if _rc {
			window stopbox stop "The list of times you specified is not valid."
		}
		local at " at(`r(numlist)')"
	}
	if $D_rb1==2 & "$D_bins"!="" & `wc1'>0 {
		errrange "$D_bins" "Number of bins" 2 100 "" int
		qui inspect $D_var1
		if _result(7)<$D_bins {
			window stopbox stop "You have specified more bins than there are unique values of $D_var1"
		}
		cap drop __group
		di in wh "${D_dot}xtile __group=$D_var1, n($D_bins)"
		global D_dot ". "
		window push xtile __group=$D_var1, n($D_bins)
		qui xtile __group=$D_var1, n($D_bins)
		local by "by(__group)"
		local i 1
		qui sum __group
		local ngs=r(max)
		cap label drop _grpv
		while `i'<=`ngs' {
			qui sum $D_var1 if __group==`i'
			local lo : display %3.2f `r(min)'
			local hi : display %3.2f `r(max)'
			label define _grpv `i' "$D_var1: `lo' - `hi'", add
			local i=`i'+1
		}
		label values __group _grpv
		label variable __group "$D_var1"
	}
	global D_ocmd "sts list, `by'`at'"
	exit 3001
end

program define libin
	global D_bins = $D_bins + `1'
	if $D_bins<1 { global D_bins 1 }
	global D_rb1 2
end

