*! version 1.0.0  16sep98 arb
program define tchidlg
	version 5.0
	precmd tchidlg

	window control static D_sm1 5 5 75 8 left
	global D_sm1 "Row variable"
	window control ssimple D_vl 5 15 75 60 D_var1
	window control static D_sm2 85 5 75 8 left
	global D_sm2 "Column variable"
	window control ssimple D_vl 85 15 75 60 D_var2
	window control static D_sm4 2 77 162 61 blackframe
	window control static D_sm5 62 74 42 10 center
	global D_sm5 "Options"
	window control check "Report expected frequencies" 5 85 100 9 D_cb1 right
	window control check "Report raw residuals" 5 95 100 9 D_cb2 right
	window control check "Report Pearson residuals" 5 105 100 9 D_cb3 right
	window control check "Report contribution to Chi-squared" 5 115 120 9 D_cb4 right
	window control check "Report adjusted residuals" 5 125 100 9 D_cb5 right
	getnv
	global D_vl "$S_1"
	window control button "OK"     12 143 30 16 D_b4
	window control button "Cancel" 50 143 30 16 D_b5
	window control button "Help"   88 143 30 16 D_b6 help
        window control button "Example" 126 143 30 16 D_b7
	global D_b4 "noi tchiok"
	global D_b5 "exit 3000"
	global D_b6 "whelp tchidlg"
        global D_b7 "whelp tchismp"
	cap noi window dialog "Chi-squared of rxc table" . . 175 175
end

program define tchiok
	version 5.0
	local wc1: word count $D_var1
	local wc2: word count $D_var2
	if `wc1'+`wc2'!=2 {
		window stopbox stop "Please specify one row variable" "and one column variable"
	}
	errvar "$D_var1 $D_var2"
	cap confirm string var $D_var1
	if !_rc {
		window stopbox stop "$D_var1 is a string variable." /*
			*/ "Please use only a numeric row variable."
		exit
	}
	cap confirm string var $D_var2
	if !_rc {
		window stopbox stop "$D_var2 is a string variable." /*
			*/ "Please use only a numeric column variable."
		exit
	}
	if "$D_cb1$D_cb2$D_cb3$D_cb4$D_cb5"=="11111" {
                window stopbox stop "Sorry - you may only specify a maximum of four options."
                exit
        }
	if "$D_cb1"=="0" {
		local opt "noe"
	}
	if "$D_cb2"=="1" {
		local opt "`opt' raw"
	}
	if "$D_cb3"=="1" {
		local opt "`opt' pearson"
	}
	if "$D_cb4"=="1" {
		local opt "`opt' cont"
	}
	if "$D_cb5"=="1" {
		local opt "`opt' adjust"
	}
	di in wh "tabchi $D_var1 $D_var2, `opt'"
	window push tabchi $D_var1 $D_var2, `opt'
	tabchi $D_var1 $D_var2, `opt'
        exit 3000
end

